//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

int forbiddennick(const unsigned char* n) {
	int r = 0;
	while (r < MAXRESERVEDNICKS) {
		if (cuo.reservednick[r] != NULL) {
			if (matches(n,cuo.reservednick[r]) == true) {
				return r;
			}
		}
		r++;
	}
	return -1;
}
bool isfakeuser(const unsigned char* usr) {
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (isfakeservicesuser(usr) == true) {return true;}
	}
#endif
	return false;
}
void sendStartup(int userid) {
	unsigned char response[400];
	usnd(userid,"NOTICE AUTH :*** Welcome. Send your authentication");
}
void authpong(int userid) {
	unsigned char* r;
	if (userpointers[userid]->pleaseremove == true) {return;}
	if (userpointers[userid]->authpongvalue > 0) {return;}
	if (userpointers[userid]->authed == true) {return;}
	
	unsigned char* gline = glined(userid,1);
	if (gline != NULL) {
		unsigned char snd[500];
		snprintf(snd,499,"ERROR: G-lined: %s",gline);
		snd[499] = 0;
		vsnd(snd,userid);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	gline = glined(userid,0);
	if (gline != NULL) {
		unsigned char snd[500];
		snprintf(snd,499,"ERROR: K-lined: %s",gline);
		snd[499] = 0;
		vsnd(snd,userid);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
#ifdef SERVICES_ENFORCEDPROTECT
		if (strcasecmp(userpointers[userid]->pass,"") == 0) {
			if (services_userregistered(userpointers[userid]->nickname) == true) {
				usnd(userid,":%s 433 AUTH %s :Nickname needs password",cuo.svd,userpointers[userid]->nickname);
				strcpy(userpointers[userid]->nickname,"");
				return;
			}
		}else{
			if (services_userregistered(userpointers[userid]->nickname) == true) {
				r = services_upassword(userpointers[userid]->nickname);
				if (r == NULL) {
					usnd(userid,":%s 433 AUTH %s :The server is currently experiencing a database problem. Renaming to something starting with 'guest' gives you access to the server in every case",cuo.svd,userpointers[userid]->nickname);
					strcpy(userpointers[userid]->nickname,"");
					return;
				}else{
					if (strcasecmp(r,"") != 0) {
						if (strcasecmp(userpointers[userid]->pass,r) != 0) {
							usnd(userid,"ERROR :Closing link: Password for %s is wrong",userpointers[userid]->nickname);
							userQuit(userid,USERQUIT_ERROR);
							free(r);
							return;
						}else{
							//set registered flag
							userpointers[userid]->accountname = malloc(strlen(userpointers[userid]->nickname) + 1);
							if (userpointers[userid]->accountname == NULL) {
								usnd(userid,":%s 433 AUTH %s :The server is currently experiencing a memory allocation problem. Renaming to something starting with 'guest' gives you access to the server in every case",cuo.svd,userpointers[userid]->nickname);
								strcpy(userpointers[userid]->nickname,"");
								free(r);
								return;
							}
							strcpy(userpointers[userid]->accountname,userpointers[userid]->nickname);
							usnd(userid,":%s NOTICE %s :*** You are now logged in (NickServ)",cuo.svd,userpointers[userid]->nickname);
							free(r);
						}
					}
				}
			}
		}
#endif
#ifndef SERVICES_ENFORCEDPROTECT
	if (services_userregistered(userpointers[userid]->nickname) == true) {
		userpointers[userid]->notifyregistered = 1;
		userpointers[userid]->needstimeout = 1;
	}
#endif
	}
#endif
	long l = ts();
	userpointers[userid]->authpongvalue = l;
	usnd(userid,"PING :%ld",l);
	return;
}
unsigned char getchannelmodes_staticbuffer[500];
unsigned char* GetChannelModes(int chanid, bool outside) {
	char tempstr[PROCESSLENGTH];
	strcpy(getchannelmodes_staticbuffer,"n\0");
	if (chans[chanid]->mode_blockcolours == true) {strcat(getchannelmodes_staticbuffer,"c\0");}
	if (chans[chanid]->mode_moderated == true) {strcat(getchannelmodes_staticbuffer,"m\0");}
	if (chans[chanid]->mode_private == true) {strcat(getchannelmodes_staticbuffer,"s\0");}
	if (chans[chanid]->mode_topiclock == true) {strcat(getchannelmodes_staticbuffer,"t\0");}
	if (chans[chanid]->mode_registered == true) {strcat(getchannelmodes_staticbuffer,"r\0");}
	if (chans[chanid]->mode_inviteonly == true) {strcat(getchannelmodes_staticbuffer,"i\0");}
	if (chans[chanid]->userlimit > 0) {strcat(getchannelmodes_staticbuffer,"l\0");}
	if (chans[chanid]->password != 0) {strcat(getchannelmodes_staticbuffer,"k\0");}
	if (chans[chanid]->userlimit > 0 && outside == false) {sprintf(&tempstr[0]," %d",chans[chanid]->userlimit);strcat(getchannelmodes_staticbuffer,tempstr);}
	if (chans[chanid]->password != 0 && outside == false) {strcat(getchannelmodes_staticbuffer," ");strcat(getchannelmodes_staticbuffer,chans[chanid]->password);}
	return getchannelmodes_staticbuffer;
}
void makeuseridvalid(unsigned char* userid) {
	unsigned char neu[20] = "";
	if (strlen(userid) < 1) {
		strcpy(userid,"");
		return;
	}
	int fcount2;
	bool isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(userid) - 1 && strlen(neu) < 9 && fcount2 < 20) {
		isokay = false;
		if (userid[fcount2] >= 65 && userid[fcount2] <= 90) {//big letters
			isokay = true;
		}
		if (userid[fcount2] >= 97 && userid[fcount2] <= 122) {//small letters
			isokay = true;
		}
		if (userid[fcount2] >= 48 && userid[fcount2] <= 57) {//numbers
			isokay = true;
		}
		if (userid[fcount2] == 95 && fcount2 >= 1) {//underlined _ - NOT AT THE BEGINNING
			isokay = true;
		}
		if (isokay == true) {neu[strlen(neu)+1] = 0;neu[strlen(neu)] = userid[fcount2];}
		fcount2 += 1;
	}
	strcpy(userid,neu);
}
bool nicknamevalid(char* nick) {
	if (strlen(nick) < 1) {
		return false;
	}
	int fcount2;
	int charcount;
	charcount = 0;
	bool isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(nick) - 1) {
		isokay = false;
		if (nick[fcount2] >= 65 && nick[fcount2] <= 90) {//big letters
			isokay = true;charcount += 1;
		}
		if (nick[fcount2] >= 97 && nick[fcount2] <= 122) {//small letters
			isokay = true;charcount += 1;
		}
		if (nick[fcount2] >= 48 && nick[fcount2] <= 57 && fcount2 >= 1) {//numbers - NOT AT THE BEGINNING
			isokay = true;
		}
		if (nick[fcount2] == '_' || nick[fcount2] == '^' || nick[fcount2] == '|' || nick[fcount2] == '[' || nick[fcount2] == ']' || nick[fcount2] == '(' || nick[fcount2] == ')' || nick[fcount2] == '-') {//special chars
			isokay = true;
		}
		if (isokay == false) {return false;}
		fcount2 += 1;
	}
	if (charcount <= 0) {return false;}
	return true;
}
bool nickused(const unsigned char* nick) {
	if (strlen(nick) < 1) {return false;}
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (strcasecmp(userpointers[r]->nickname,nick) == 0) {
				return true;
			}
		}
		r += 1;
	}
	return false;
}
void notenoughparameters(int userid, const unsigned char* command) {
	unsigned char send[400];
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		snprintf(&send[0],399,":%s 461 %s %s :Not enough parameters",currentoptions.serverdomain,userpointers[userid]->nickname,command);
	}else{
		snprintf(&send[0],399,":%s 461 %s %s :Not enough parameters",currentoptions.serverdomain,"AUTH",command);
	}
	send[399] = 0;
	vsnd(send,userid);
}
void sendserviceswhois(int userid, const unsigned char* svbot) {
#ifdef SERVICES_ENABLED
	unsigned char pam[50];
	strncpy(pam,svbot,49);
	pam[49] = 0;
	writeservicesnick(pam);
	usnd(userid,":%s 311 %s %s services %s * :Services",cuo.svd,un(userid),pam,cuo.serviceshost);
	usnd(userid,":%s 312 %s %s %s :%s",cuo.svd,un(userid),pam,cuo.svd,cuo.serverdesc);
	usnd(userid,":%s 335 %s %s :is a services bot",cuo.svd,un(userid),pam);
	usnd(userid,":%s 318 %s %s :End of /WHOIS",cuo.svd,un(userid),pam);
#endif
}
void sendwhois(int userid,int targetid) {
	usnd(userid,":%s 311 %s %s %s %s * :%s",cuo.svd,un(userid),un(targetid),userpointers[targetid]->suserid,userpointers[targetid]->host,userpointers[targetid]->realname);
	usnd(userid,":%s 312 %s %s %s :%s",cuo.svd,un(userid),un(targetid),cuo.svd,cuo.serverdesc);
	if (userpointers[targetid]->awayreason != NULL) {
		if (strcasecmp(userpointers[targetid]->awayreason,"") != 0) {
			usnd(userid,":%s 301 %s %s :%s",cuo.svd,un(userid),un(targetid),userpointers[targetid]->awayreason);
		}
	}
	if (userpointers[targetid]->ircop == true) {
		usnd(userid,":%s 313 %s %s :is an IRC operator",cuo.svd,un(userid),un(targetid));
	}
	if (userpointers[targetid]->mode_bot == true) {
		usnd(userid,":%s 335 %s %s :is a bot",cuo.svd,un(userid),un(targetid));
	}
#ifdef SERVICES_ENABLED
	if (userpointers[targetid]->accountname != NULL) {
		usnd(userid,":%s 320 %s %s :is identified as %s",cuo.svd,un(userid),un(targetid),userpointers[targetid]->accountname);
	}
#endif
	usnd(userid,":%s 318 %s %s :End of /WHOIS",cuo.svd,un(userid),un(targetid));
}
#define COUNT_ALL 1
#define COUNT_LOCAL 2
#define COUNT_OPS 3
int usercount(int type) {
	int r = 0;
	int k = 0;
	while (r < userslotcount) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->pleaseremove == false && userpointers[r]->authed == true && (userpointers[r]->hopcount <= 0 || type != COUNT_LOCAL) && (userpointers[r]->ircop == true || type != COUNT_OPS)) {
				k += 1;
			}
		}
		r += 1;
	}
	return k;
}
int servercount() {
	int k = 1;
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			k++;
		}
		r++;
	}
	return k;
}
int max_ucount;
int max_ucount_local;
void sendlusers(int userid) {
	int invis = 0;
	int ucount = usercount(COUNT_ALL);
	int ucount_local = usercount(COUNT_LOCAL);
	#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		ucount += 4;invis += 4;ucount_local += 4;
	}
	#endif
	if (ucount > max_ucount) {max_ucount = ucount;}
	if (ucount_local > max_ucount_local) {max_ucount_local = ucount_local;}
	usnd(userid,":%s 251 %s :There are %d users and %d invisible on %d servers",cuo.svd,un(userid),ucount-invis,invis,servercount());
	usnd(userid,":%s 252 %s :%d operator(s) online",cuo.svd,un(userid),usercount(COUNT_OPS));
	usnd(userid,":%s 255 %s :I have %d clients and %d servers",cuo.svd,un(userid),usercount(COUNT_LOCAL),servercount());
	usnd(userid,":%s 265 %s :Current local users: %d  Max: %d",cuo.svd,un(userid),ucount_local,max_ucount_local);
	usnd(userid,":%s 266 %s :Current global users: %d  Max: %d",cuo.svd,un(userid),ucount,max_ucount);
}
void sendwho(int chan, int user, int targetuser) {
	//:zelazny.freenode.net 352 Yarcanox #devurandom n=JPT star-sim.de irc.freenode.net JPT G :0 Jan Philipp Timme
	unsigned char channame[500];
	if (chan >= 0) {
		strncpy(channame,chans[chan]->name,499);
		channame[499] = 0;
	}else{
		strcpy(channame,"*");
	}
	unsigned char flags[5] = "";
	if (userpointers[user]->awayreason == NULL) {
		strcpy(flags,"H");
	}else{
		if (strcasecmp(userpointers[user]->awayreason,"") == 0) {
			strcpy(flags,"H");
		}else{
			strcpy(flags,"G");
		}
	}
	if (userpointers[user]->ircop == true) {
		strcat(flags,"*");
	}
	if (chan >= 0) {
		if (isoponchan(user,chan) == true) {
			strcat(flags,"@");
		}else{
			if (ishoponchan(user,chan) == true) {
				strcat(flags,"%");
			}else{
				if (isvoiceonchan(user,chan) == true) {
					strcat(flags,"+");
				}else{
					
				}
			}
		}
	}
	usnd(targetuser,":%s 352 %s %s %s %s %s %s %s :0 %s",cuo.svd,un(targetuser),channame,userpointers[user]->suserid,userpointers[user]->host,cuo.svd,un(user),flags ,userpointers[user]->realname);
}
void authdone(int userid) {
	unsigned char send[501];
	strcpy(userpointers[userid]->host,generate_vhost_guest(userpointers[userid]->ip));
#ifdef SERVICES_ENABLED
	if (userpointers[userid]->accountname != NULL) {
		if (strcasecmp(userpointers[userid]->accountname,"") != 0) {
			const unsigned char* p = generate_vhost_user(userpointers[userid]->accountname,userpointers[userid]->ip);
			if (p != NULL) {
				strcpy(userpointers[userid]->host,p);
			}
		}
	}
#endif
	userpointers[userid]->ping_lastping = ts();
	userpointers[userid]->authed = true;
	userpointers[userid]->lastnickchange = ts();
	usnd(userid,":%s 001 %s :Welcome to %s %s",cuo.svd,un(userid),cuo.networkname,un(userid));
	usnd(userid,":%s 002 %s :Your host is %s, running WeIRCd%s",cuo.svd,un(userid),cuo.svd,bigversion);
	usnd(userid,":%s NOTICE %s :*** Your host is %s, running WeIRCd%s",cuo.svd,un(userid),cuo.svd,bigversion);
	usnd(userid,":%s 003 %s :This server was created on a rainy monday",cuo.svd,un(userid));
	usnd(userid,":%s 004 %s %s WeIRCd%s iows bcihklmnOostv",cuo.svd,un(userid),cuo.svd,bigversion);
	usnd(userid,":%s 005 %s CHANTYPES=# PREFIX=(ohv)@%%+ NETWORK=%s AWAYLEN=%d :are supported by this server",cuo.svd,un(userid),cuo.networkname, COMPILEOPTION_MAXAWAYLEN);
	usnd(userid,":%s 005 %s CHANLIMIT=#:%d IRCD=WeIRCd NICKLEN=%d CASEMAPPING=ascii USERLEN=9 :are supported by this server",cuo.svd,un(userid),cuo.vmaxchansperuser,COMPILEOPTION_MAXNICKLEN);
	usnd(userid,":%s 005 %s CHANMODE=b,k,l,cimnst PENALTY MAXTARGETS=1 MAXBANS=%d MODES=%d :are supported by this server",cuo.svd,un(userid),MAXBANSPERCHAN,MAXPARAMMODES);
	sendlusers(userid);
	motd_send(userid);
	up[userid]->floodprotect.lastmotd = ts();
	//introduce this user to linked servers
	snprintf(send,499,"adduser :%s %lld",up[userid]->nickname,ts());send[499] = 0;
	sendalllinks(send);
	//printf("introducing new user %s\n",up[userid]->nickname);
#ifdef SERVICES_ENABLED
	if (userpointers[userid]->notifyregistered == 1) {
		services_say("NickServ","This nickname is registered. Please login if it has been registered by you.",userid);
		if (SERVICES_LOGINTIMEOUT > 0) {
			snprintf(send,499,"You have %c%d seconds%c to login or you will be renamed.",2,SERVICES_LOGINTIMEOUT,2);send[499] = 0;
			services_say("NickServ",send,userid);
		}
	}
#endif
}
void sendversion(int r) {
#if !defined(osname)
	usnd(r,":%s 351 %s WeIRCd%s subvers%s :",cuo.svd,un(r),bigversion,version_detail);
#endif
#if defined(osname)
	usnd(r,":%s 351 %s WeIRCd%s %s-%s :",cuo.svd,un(r),bigversion,osname,version_detail);
#endif
}
bool isvalidchanname(const unsigned char* channame) {
	int r = 0;
	while (r < strlen(channame)) {
		if (channame[r] == '#' || (channame[r] >= 'a' && channame[r] <= 'z') || (channame[r] >= 'A' && channame[r] <= 'Z') || (channame[r] >= '0' && channame[r] <= '9') || channame[r] == '_' || channame[r] == '-' || channame[r] == '.' || channame[r] == ':' || channame[r] == '!' || channame[r] == '/' || channame[r] == '\\' || channame[r] == '[' || channame[r] == ']' || channame[r] == '(' || channame[r] == ')' || channame[r] == '?' || channame[r] == '+' || channame[r] == '*' || channame[r] == '<' || channame[r] == '>' || channame[r] == ';') {
			
		}else{
			return false;
		}
		r += 1;
	}
	return true;
}
void infol(int userid, const unsigned char* line) {
	usnd(userid,":%s 371 %s :%s",cuo.svd,un(userid),line);
}
void infoend(int userid) {
	usnd(userid,":%s 374 %s :End of /INFO list",cuo.svd,un(userid));
}
void sendinfo(int u) {
	infol(u,"---- WeIRCd (c) by Jonas Thiem ----");
	infol(u,"This IRCd is a chat server software");
	infol(u,"written from scratch. It is free");
	infol(u,"for use and the source code is also");
	infol(u,"free to read (see");
	infol(u,"http://eloxoph.net/weircd/ for");
	infol(u,"details).");
	infol(u,"This software has mainly been");
	infol(u,"developed and founded by");
	infol(u,"Jonas 'Elmaron' Thiem.");
	infol(u," ");
	infol(u,"Special thanks go to:");
	infol(u," * me1357 & LongHairedHacker for C");
	infol(u,"   teaching (you made this");
	infol(u,"   possible!)");
	infol(u," * IRWolfie- for great help with");
	infol(u,"   the secrets of the IRC protocol");
	infol(u," * shahri & DUX for always sharing");
	infol(u,"   thoughts");
	infol(u," * one big thanks to DUX for always");
	infol(u,"   helping with debugging");
	infol(u," * To all the other guys helping me");
	infol(u,"-----------------------------------");
	infoend(u);
}
void sendchanusers(int user,int chan) {
	unsigned char sendbase[501];
	if (chans[chan]->hopcount > 0) {
		snprintf(sendbase,499,":%s!%s@%s NAMES %s",up[user]->nickname,up[user]->suserid,up[user]->host,chans[chan]->name);sendbase[499] = 0;
		sendontcp(sendbase,chans[chan]->linktcpdata);
		return;		
	}
	
	snprintf(&sendbase[0],499,":%s 353 %s = %s :",cuo.svd,un(user),chans[chan]->name);
	sendbase[499] = 0;
	unsigned char send[501];
	unsigned char pref;
	int r = 0;
	int c = 0;
	strcpy(send,sendbase);
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (chanregistered(chans[chan]->name) == true) {
			strcat(send,"@ChanServ");
			c++;
		}
	}
#endif
	while (r < userslotcount) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->authed == true && userpointers[r]->pleaseremove == false) {
				if (isuserinchan(r,chan) == true) {
					if (strlen(send) + strlen(un(r)) + 2 < 499) {
						c += 1;
						if (c > 1) {strcat(send," ");}
						pref = userprefix(r,chan);
						if (pref != 0) {send[strlen(send)+1] = 0;send[strlen(send)] = pref;}
						strcat(send,un(r));
					}else{
						usnd(user,send);
						strcpy(send,sendbase);
						pref = userprefix(r,chan);
						if (pref != 0) {send[strlen(send)+1] = 0;send[strlen(send)] = pref;}
						strcat(send,un(r));
						c = 1;
					}
				}
			}
		}
		r += 1;
	}
	if (c > 0) {usnd(user,send);}
	usnd(user,":%s 366 %s %s :End of /NAMES list",cuo.svd,un(user),chans[chan]->name);
}
void sendtopic(int userid,int chan) {
	unsigned char send[501];
	if (chans[chan]->hopcount <= 0) {
		if (chans[chan]->topic_settime > 0) {//gibtn topic
			usnd(userid,":%s 332 %s %s :%s",cuo.svd,un(userid),chans[chan]->name,chans[chan]->topic);
			usnd(userid,":%s 333 %s %s %s %d",cuo.svd,un(userid),chans[chan]->name,chans[chan]->topic_setby,chans[chan]->topic_settime);
			return;
		}else{//gibt kein topic
			usnd(userid,":%s 331 %s %s :No topic is set",cuo.svd,un(userid),chans[chan]->name);
		}
	}else{
		snprintf(send,500,":%s!%s@%s TOPIC %s",un(userid),up[userid]->suserid,up[userid]->host,chans[chan]->name);send[500] = 0;
		sendtoservid(send,chans[chan]->linktcpdata);
	}
}
void moveoutofchan(int userid,const unsigned char* channame, const unsigned char* reason) {
	unsigned char lclchanname[200];
	unsigned char send[501];
	strncpy(lclchanname,channame,199);lclchanname[199] = 0;
	trimleft(lclchanname);cutonfirstspace(lclchanname);
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	int r;
	int k = 0;
	k = getChanID(lclchanname);
	if (k < 0) {
		usnd(userid,":%s 442 %s %s :You are not in this channel",cuo.svd,un(userid),lclchanname);
		return;
	}else{
		if (isuserinchan(userid,k) == false) {
			usnd(userid,":%s 442 %s %s :You are not in this channel",cuo.svd,un(userid),lclchanname);
			return;
		}else{
			snprintf(&send[0],499,":%s!%s@%s PART %s :",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,chans[k]->name);
			send[499] = 0;
			if (up[userid]->hopcount <= 0) {
				tellallusersinchan(send,k);
			}else{
				tellallusersinchan_local(send,k);
			}
			r = 0;
			while (r < COMPILEOPTION_MAXCHANSPERUSER) {
				if (userpointers[userid]->chan[r] != NULL) {
					if (userpointers[userid]->chan[r]->chanid == k) {free(userpointers[userid]->chan[r]);userpointers[userid]->chan[r] = NULL;}
				}
				r += 1;
			}
			removeemptychans();
		}
	}
}
void localpart(int userid,const unsigned char* channame, const unsigned char* reason) {
	unsigned char send[512];
	printf("processing local part\n");
	int r = getChanID(channame);
	printf("id is %d\n",r);
	if (r >= 0) {
		if (chans[r]->hopcount > 0) {
			snprintf(send,511,":%s!%s@%s PART %s :%s",up[userid]->nickname,up[userid]->suserid,up[userid]->host,chans[r]->name,reason);send[511] = 0;
			sendalllinks(send);
		}
	}
	moveoutofchan(userid,channame,reason);
}
void sendlinks(int userid) {
	usnd(userid,":%s 364 %s %s %s :0 %s",cuo.svd,un(userid),cuo.svd,cuo.svd,cuo.serverdesc);
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (svlinked[r] != NULL) {
				usnd(userid,":%s 364 %s %s %s :%d %s",cuo.svd,un(userid),svnames[r],svlinked[r],svhop[r],svdesc[r]);
			}else{
				usnd(userid,":%s 364 %s %s %s :%d %s",cuo.svd,un(userid),svnames[r],cuo.svd,svhop[r],svdesc[r]);
			}
		}
		r++;
	}
	usnd(userid,":%s 365 %s * :End of /LINKS list",cuo.svd,un(userid));
}
void localjoin(int userid,const unsigned char* channame) {
	unsigned char send[512];
	printf("processing local join\n");
	int r = getChanID(channame);
	printf("id is %d\n",r);
	if (r >= 0) {
		printf("it exists!\n");printf("hopcount is %d\n",chans[r]->hopcount);
		if (chans[r]->hopcount > 0) {
			snprintf(send,511,":%s!%s@%s WANTJOIN %s",up[userid]->nickname,up[userid]->suserid,up[userid]->host,chans[r]->name);send[511] = 0;
			sendtoservname(chans[r]->servname,send);
			return;
		}
	}
	moveintochan(userid,channame);
}
void moveintochan(int userid,const unsigned char* channame) {
	printf("%s -> %s\n",up[userid]->nickname,channame);
	unsigned char lclchanname[200];
	unsigned char send[513];
	strncpy(lclchanname,channame,199);lclchanname[199] = 0;
	trimleft(lclchanname);cutonfirstspace(lclchanname);
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	if (isvalidchanname(lclchanname) == false) {
		usnd(userid,":%s 479 %s %s :Illegal channel name",cuo.svd,un(userid),lclchanname);
		return;
	}
	if (lclchanname[0] != '#') {
		strcpy(send,"#");strcat(send,lclchanname);
		strncpy(lclchanname,send,199);
		lclchanname[199] = 0;
	}
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	int r = 0;
	int k = -1;
	while (r < COMPILEOPTION_MAXCHANSPERUSER && (r < cuo.vmaxchansperuser || up[r]->hopcount <= 0)) {
		if (userpointers[userid]->chan[r] == NULL) {k = r;break;}
		r += 1;
	}
	if (k < 0) {//already on too many channels
		usnd(userid,":%s 405 %s %s :You are already in too many channels",cuo.svd,un(userid),lclchanname);
		return;
	}
	bool iamop = false;
	bool iamprotected = false;
	if (up[userid]->hopcount <= 0) {//if a local user, check for getting opped etc
		iamop = isOppedOnJoin(userid,lclchanname);
		iamprotected = isProtected(userid,lclchanname);
	}
	r = addChan(lclchanname);
	if (r < 0) {
		usnd(userid,":%s 405 %s %s :Global chan limit is full",cuo.svd,un(userid),lclchanname);
		return;
	}
	if (isuserinchan(userid,r) == true) {
		return;
	}
	if (userpointers[userid]->ircop == false && iamprotected == false) {
		unsigned char mymask[MAXUSERMASKLEN+1];
		snprintf(mymask,MAXUSERMASKLEN,"%s!%s@%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host);
		mymask[MAXUSERMASKLEN] = 0;
		int j = 0;
		while (j < MAXBANSPERCHAN) 	{
			if (chans[r]->ban[j] != NULL) {
				if (matches(mymask,chans[r]->ban[j]->mask) == true) {
					usnd(userid,":%s 474 %s %s :You're banned from that channel",cuo.svd,un(userid),chans[r]->name);
					return;
				}
			}
			j++;
		}
	}
	int introduced = 0;
	if (chanusercount(r) <= 0) {
		//new local channel, introduce it
		introduced = 1;
		snprintf(send,512,"addchan :%s %lld",chans[r]->name,chans[r]->creationtime);
		send[511];
		sendalllinks(send);
	}
	userpointers[userid]->chan[k] = malloc(sizeof(struct weircd_user_chaninfo));
	if (userpointers[userid]->chan[k] == NULL) {
		usnd(userid,":%s 400 %s JOIN :Error - out of memory",cuo.svd,un(userid));
		if (introduced == 1) { 
			snprintf(send,512,"delchan :%s %lld",chans[r]->name,chans[r]->creationtime);
			send[511];
			sendalllinks(send);
		}
		return;
	}
	
	memset(userpointers[userid]->chan[k],0,sizeof(struct weircd_user_chaninfo));
	userpointers[userid]->chan[k]->chanid = r;
	userpointers[userid]->chan[k]->iamop = iamop;
	userpointers[userid]->chan[k]->iamprotected = iamprotected;
	snprintf(&send[0],499,":%s!%s@%s JOIN %s",userpointers[userid]->nickname,userpointers[userid]->suserid,userpointers[userid]->host,chans[r]->name);
	send[499] = 0;
	tellallusersinchan_local(send,r);
	links_servers_flagusersofchan(r);
	sendallflagged(send);
	if (iamop == true) {
		usnd(userid,":ChanServ!services@%s MODE %s +o %s",cuo.serviceshost,chans[r]->name,un(userid));
	}
	sendtopic(userid,r);
	sendchanusers(userid,r);
}
void notimplemented(int userid, const unsigned char* command) {
	unsigned char response[501];
	usnd(userid,":%s 400 %s %s :%s is not implemented yet",cuo.svd,un(userid),command,command);
}
#include "weircd_irccommands.c"
void userCMD(int userid, const unsigned char* command, const unsigned char* parameters) {
	if (userpointers[userid]->authed == true) {
		if (userpointers[userid]->ping_waitingforpong < ts()-5 && userpointers[userid]->ping_waitingforpong > 0) {
			userpointers[userid]->ping_waitingforpong = ts()-5;
		}
	}
	unsigned char cmd[40];
	strncpy(cmd,command,39);cmd[39] = 0;
	unsigned char params[520];
	strncpy(params,parameters,519);params[519] = 0;
	unsigned char response[521];
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (strcasecmp(cmd,"nickserv") == 0) {
			strcpy(response,params);
			strcpy(params,"NickServ :");
			strncat(params,response,519);
			params[519] = 0;
			strcpy(cmd,"privmsg");
		}
		if (strcasecmp(cmd,"chanserv") == 0) {
			strcpy(response,params);
			strcpy(params,"ChanServ :");
			strncat(params,response,519);
			params[519] = 0;
			strcpy(cmd,"privmsg");
		}
		if (strcasecmp(cmd,"operserv") == 0) {
			strcpy(response,params);
			strcpy(params,"OperServ :");
			strncat(params,response,519);
			params[519] = 0;
			strcpy(cmd,"privmsg");
		}
	}
#endif
#ifdef ACTIVATEDEBUG
//	printf(">>[%d] %s %s\n",userid,cmd,params);
#endif
	if (strcasecmp(cmd,"NICK") == 0) {cmd_nick(userid,params);return;}
	if (strcasecmp(cmd,"USER") == 0) {cmd_user(userid,params);return;}
	if (strcasecmp(cmd,"PONG") == 0) {cmd_pong(userid,params);return;}
	if (strcasecmp(cmd,"PRIVMSG") == 0) {userpointers[userid]->floodprotect.floodpoints += 1;cmd_privmsg(userid,params);return;}
	if (strcasecmp(cmd,"LUSERS") == 0) {
		if (x(userid,"LUSERS")) {return;}
		sendlusers(userid);
		return;
	}
	if (strcasecmp(cmd,"VERSION") == 0) {if (x(userid,"VERSION")) {return;}sendversion(userid);return;}
	if (strcasecmp(cmd,"PING") == 0) {cmd_ping(userid,params);return;}
	if (strcasecmp(cmd,"NOTICE") == 0) {userpointers[userid]->floodprotect.floodpoints += 1;cmd_notice(userid,params);return;}
	if (strcasecmp(cmd,"LINKS") == 0) {userpointers[userid]->floodprotect.floodpoints += 1;cmd_links(userid,params);return;}
	if (strcasecmp(cmd,"NAMES") == 0) {cmd_names(userid,params);return;}
	if (strcasecmp(cmd,"JOIN") == 0) {cmd_join(userid,params);return;}
	if (strcasecmp(cmd,"PART") == 0) {cmd_part(userid,params);return;}
	if (strcasecmp(cmd,"OPER") == 0) {cmd_oper(userid,params);return;}
	if (strcasecmp(cmd,"KILL") == 0) {cmd_kill(userid,params);return;}
	if (strcasecmp(cmd,"GLINE") == 0) {cmd_gline(userid,params,1);return;}
	if (strcasecmp(cmd,"KLINE") == 0) {cmd_gline(userid,params,0);return;}
	if (strcasecmp(cmd,"LIST") == 0) {cmd_list(userid,params);return;}
	if (strcasecmp(cmd,"TOPIC") == 0) {cmd_topic(userid,params);return;}
	if (strcasecmp(cmd,"QUIT") == 0) {cmd_quit(userid,params);return;}
	if (strcasecmp(cmd,"WHOIS") == 0) {cmd_whois(userid,params);return;}
	if (strcasecmp(cmd,"MODE") == 0) {cmd_mode(userid,params);return;}
	if (strcasecmp(cmd,"REHASH") == 0) {cmd_rehash(userid,params);return;}
	if (strcasecmp(cmd,"PASS") == 0) {cmd_pass(userid,params);return;}
	if (strcasecmp(cmd,"WHO") == 0) {cmd_who(userid,params);return;}
	if (strcasecmp(cmd,"WHOWAS") == 0) {cmd_whowas(userid,params);return;}
	if (strcasecmp(cmd,"ISON") == 0) {cmd_ison(userid,params);return;}
	if (strcasecmp(cmd,"AWAY") == 0) {cmd_away(userid,params);return;}
	if (strcasecmp(cmd,"KICK") == 0) {cmd_kick(userid,params);return;}
	if (strcasecmp(cmd,"STATS") == 0) {cmd_stats(userid,params);return;}
	if (strcasecmp(cmd,"INFO") == 0) {cmd_info(userid,params);return;}
	if (strcasecmp(cmd,"MOTD") == 0) {cmd_motd(userid,params);return;}
#ifdef SRAW
	if (strcasecmp(cmd,"SRAW") == 0) {cmd_sraw(userid,params);return;}
#endif
	userpointers[userid]->floodprotect.floodpoints += 1;
	strupper(cmd);
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		usnd(userid,":%s 421 %s %s :Command unknown",cuo.svd,un(userid),cmd);
	}else{
		usnd(userid,":%s 421 * %s :Command unknown",cuo.svd,cmd);
	}
}
